#include <stdio.h>
#include <string.h>

#include <opencv2/opencv.hpp>
#include <custom_sort.hpp>

#include <stdlib.h>

//Images from camera are 672*376, each region is 8*8
#define ROWS 47
#define COLS 84
//Customizable number of samples, should be odd number
#define SAMPLES 15


struct depth_point{
    int row;
    int col;
    float val;
};

int POINT_VALUE[ROWS][COLS][2] = {}; //Can be changed to include heigth
int POINT_POSITION[ROWS][COLS][2] = {};

int get_regions(cv::Mat depth_img){
	//do stuff
	for (int i = 0; i < ROWS; i++){
		for (int j = 0; j < COLS; j++){
			depth_point depth_list[SAMPLES] = {};
			for (int k = 0; k < SAMPLES; k++){
				int row = rand() % 8+(i*8);
				int col = rand() % 8+(j*8);
				depth_list[k].val = depth_img.at<float>(row)(col);
				depth_list[k].row = row;
				depth_list[k].col = col;
			}
			//sort depth_list
			depth_point sorted_list[SAMPLES];
			depth_point *sorted_pointer;
			sorted_pointer = depth_sorter(depth_list);
			for (int counter = 0; counter < SAMPLES; counter++){
                sorted_list[counter] = *(sorted_pointer+counter);
			}
			//get the median value
			int median = (SAMPLES+1)/2;
            float median_val = sorted_list[median].val;
            if (0.6 < median_val < 7.1){
                POINT_VALUE[i][j][1] = median_val;
                int y_coord = 0;
                int y_denominator = 0;
                if (median_val < 1.3){
                    y_denominator = 682 - 320*median_val; //tuning parameters found experimentally
                }
                else{
                    y_denominator = 1/(0.00025 + 0.003*median_val); //tuning parameters found experimentally
                }
                POINT_VALUE[i][j][2] = y_coord/y_denominator;
                POINT_POSITION[i][j][1] = sorted_list[median].row;
                POINT_POSITION[i][j][2] = sorted_list[median].col;
            }
            else{
                POINT_VALUE[i][j][1] = 15000;
                POINT_VALUE[i][j][2] = 15000;
                POINT_POSITION[i][j][1] = 999;
                POINT_POSITION[i][j][2] = 999;
            }
		}
	}
	//Implement region growing
    uint8_t R[8*ROWS][8*COLS] = {};
    uint8_t visited[ROWS][COLS]; //Should have values from 0-2; 0 unvisited, 1 visited but unclassified, 2 classified
    bool region_flag = false;
    //Fill in with values
    for (int i = 0; i < ROWS; i++){
        for (int j = 0; j < COLS; j++){
            int current_depth_val = POINT_VALUE[i][j][1];
            int current_width_val = POINT_VALUE[i][j][2];
            int start_depth = current_depth_val;
            int start_width = current_width_val;
            region_flag = false;
            if (visited[i][j] == 2){
                region_flag = true;
            }
            else{
                visited[i][j] = 1;
            }
            while (!region_flag){
                //Check neighbors
                if !(i == 0){
                    do_stuff
                }
                if !(i == ROWS - 1){
                    do_stuff
                }
                if !(j == 0){
                    do_stuff
                }
                if !(j == COLS - 1){
                    do_stuff
                }
                do_stuff
            }
        }
    }
	return R;
}
